local player = require("Core.Player")
local loader = require("Core.AdvTiledLoader.Loader") 
require('Core.camera')

loader.path = "Maps/"
local gr = love.graphics
local rect		= gr.rectangle
local setColor	= gr.setColor
local setEffect	= gr.setPixelEffect
local canvas	= gr.newCanvas()
local min,max	= math.min,math.max
local lumens	= 0.9--torchpower
local sizeTile	= 20
local sizeView	= { gr.getWidth(), gr.getHeight() }
local pos		= { player.getX()+35,  player.getY()-20 }
local speed		= 125
local down		= love.keyboard.isDown
local effect	= gr.newPixelEffect
		[[
			extern number ts;//Tile size
			extern number pwr;
			extern vec2 pos;//Player position

			vec4 effect(vec4 colour,Image img,vec2 percent,vec2 pixel)

			{
			return Texel(img,percent)*(ts/length(pos-pixel)*pwr);
			}
		]]



canvas:renderTo(function()
	setColor(128,128,128,128)
	rect("fill",0,0,sizeView[1],sizeView[2])
	setColor(100,255,100,255)
end)

function love.load()
	camera:setBounds(0, 0, sizeView[1], sizeView[2])
    map = loader.load("test.map")
    player:initMoving()
    effect:send("ts",sizeTile)
	effect:send("pwr",lumens)
	effect:send("pos",pos)
end

function love.draw()
	camera:set()
	player:updateStats()
	setEffect( effect )
	map:draw()
	--setColor(255,255,255,255)
	gr.draw(canvas)
	effect:send("pos",pos)
	setEffect()
	player:Draw()
	setColor(255,255,100,255)
	camera:unset()
end

function love.update(t)
	player:Move(t)
	camera:setPosition(player:getX() - sizeView[1] / 2, player:getY() - sizeView[2] / 2)
	player:updateStats()
	if down'up' then pos[2]=min(sizeView[2]-sizeTile/4,(pos[2])+t)	effect:send("pos",pos) end
	if down'left'	then pos[1]=max(sizeTile/4,(player.getX()-5)-t)	effect:send("pos",pos) end
	if down'down'	then pos[2]=max(sizeTile/4,(pos[2])-t)	effect:send("pos",pos) end
	if down'right'	then pos[1]=min(sizeView[1]-sizeTile/4,(player.getX()+35)+t) effect:send("pos",pos) end
end

function love.keypressed(key)
    player:setRotate(key, false)
    effect:send("pos",pos)
end

function love.keyreleased(key)
    player:setRotate(key, true)
    effect:send("pos",pos)
end

function math.clamp(x, min, max)
return x < min and min or (x > max and max or x)
end